#!/usr/bin/perl 

#print "Content-type: text/plain\n\n";

#use strict;
use DBI;

require "/home/sage/blather/bin/config.ph";
require "$basedir/bin/blib.ph";

#my (%input,%rawinput,$command);
#my $dbh;

&GetInput;

# scheme?
my @cgiopts;
if (defined $input{'scheme'}) {
    $defaultscheme = $input{'scheme'};
    push(@cgiopts, "scheme=$defaultscheme");
}

# edition
if (defined $input{'edition'}) {
    $edition = $input{'edition'};
    push(@cgiopts, "edition=$edition");

    $htmldir .= "/$edition";
    $baseurl .= "/$edition";
    $formdir .= "/$edition";
    $dbname = "blather_$edition";
}
$cgiurl .= "/" . join('/', @cgiopts) if @cgiopts;


&Add if $command eq 'add';
&Addform if $command eq 'addform';

&Recent if $command eq 'recent';
&Who if $command eq 'who';
&Refs if $command eq 'refs';
&Showday if $command eq 'showday';

&Randomlinks if $command eq 'randomlinks';
&Random if $command eq 'random';
&Go if $command eq 'go';

print "Location: $baseurl\n\n";
exit;


## connect

sub Connect {
    # connect
    my $datasource = $dbname || "blather";
    $dbh = DBI->connect("dbi:mysql:$datasource:$dbhost", $dbuser, $dbpass)
	|| warn "Can't connect to $datasource: $DBI::errstr";
}



###################


sub Refs {
    &Connect;

    my $word = $input{'word'};
    my $r;
    my @refs;

    my $s = "SELECT word FROM entrywords WHERE entryword=\"$word\"";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    while (($r) = $sth->fetchrow_array) {
	push(@refs,$r);
    }
    $sth->finish;
    $dbh->disconnect;
    
    $form{'word'} = $word;
    $form{'url'} = &MakeUrl($word);
    
    print "Content-type: text/html\n\n" . &GetForm('refs_top');

    if (@refs) {
	my $w;
	for $w (sort @refs) {
	    print "<a href=\"" . &MakeUrl($w) . "\">$w</a><br>\n";
	}
    } else {
	print "is alone\n";
    }

    print &GetForm('refs_bottom');

    exit;
}


#
# who

sub Who {
    &Connect;

    my $num = $input{'num'} || 10;
    my $name = $input{'name'};
    $name =~ s/"/\\"/g;
    my $email = $input{'email'};
    $email =~ s/"/\\"/g;
    
    print "Content-type: text/html\n\n";

    my $s;
    if ($name || $email) {
	my $r;
	if ($email) {
	    $r = "(name=\"$name\" AND email=\"\")" if $name;
	    $r .= " OR " if $r;
	    $r .= "email=\"$email\"";
	} else {
	    $r = "name=\"$name\"" if $name;
	}
	$s = "SELECT DISTINCT word,name,email FROM entries WHERE $r ORDER BY stamp DESC";
    } else {
	# recent people
	$s = "SELECT DISTINCT word,name,email FROM entries ORDER BY stamp DESC";
    }
    
    print "<!-- s = $s -->\n";
    
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my ($word,$when,$email);
    my @names;
    while (($word,$name,$email) = $sth->fetchrow_array) {
	
	last if scalar(keys %words) == $num && $words{$name} eq '';
	
	if ($words{$name}) {
	    $words{$name} .= ' ';
	} else {
	    push(@names,$name);
	}
	$words{$name} .= $word;
	$email{$name} = $email if $email;
    }
    $sth->finish;
    $dbh->disconnect;

    print &GetForm('who_top');

    for $name (@names) {
	my $n;
	if ($email{$name}) {
	    $n = "<a href=\"mailto:$email{$name}\">$name</a>" if $name;
	    $n = "<a href=\"mailto:$email{$name}\">$email{$name}</a>" unless $name;
	} else {
	    $n = "$name" unless $email{$name};
	}
	$form{'name'} = $n;
	print (&GetForm("who_person_top") || "<tr><td align=right valign=top>$n</td>\n<td valign=top>");
	@words = split(/ /,$words{$name});
	my $last = '';
	for (@words) {
	    next if $_ eq $last;
	    $last = $_;
	    print "<a href=\"" . &MakeUrl($_) . "\">$_</a><br>\n";
	}
	print &GetForm("who_person_bottom") || "</td></tr>\n";
    }

    print &GetForm('who_bottom');

    exit;
}



#
# showday

sub Showday {
    my @days = ( 31,28,31, 30,31,30, 31,31,30, 31,30,31 );

    &Connect;

    print "Content-type: text/html\n\n";
    
    my $y = substr($input{'day'},0,2);
    if ($y < 50) {
	$y = "20" . $y;
    } else {
	$y = "19" . $y;
    }
    $day = $y . "-" . substr($input{'day'},2,2) . "-" . substr($input{'day'},4,2) . "%";


    my $s = "SELECT DISTINCT word FROM entries WHERE stamp LIKE \"$day\" order by stamp desc";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my ($word,$date);
    my @words;
    while (($word) = $sth->fetchrow_array) {
	push(@words,$word);
    }
    $sth->finish;
    $dbh->disconnect;

    print "<!-- $s -->\n";

    my ($y,$m,$d,$py,$pm,$pd,$ny,$nm,$nd,$p,$n);
    ($ny,$nm,$nd) = ($py,$pm,$pd) = $input{'day'} =~ /(\d\d)(\d\d)(\d\d)/;
    
    $pd--;
    if ($pd < 1) {
	$pm--;
	if ($pm < 1) {
	    $pm = 12;
	    $py--;
	    $py = 99 if ($py < 0);
	}
	$pd = $days[$pm-1];
    }
    $p = sprintf("%02d%02d%02d",$py,$pm,$pd);
    $form{'prevdaylink'} = "<a href=\"$cgiurl?showday;day=$p\" class=\"noline\">$p</a>";

    $nd++;
    if ($nd > $days[$nm-1]) {
	$nm++;
	if ($nm > 12) {
	    $ny++;
	    $ny = 0 if $ny >= 100;
	    $nm = 1;
	}
	$nd = 1;
    }
    $n = sprintf("%02d%02d%02d",$ny,$nm,$nd);
    $form{'nextdaylink'} = "<a href=\"$cgiurl?showday;day=$n\" class=\"noline\">$n</a>";

    $form{'day'} = $input{'day'};
    print &GetForm('day_top');

    for my $word (@words) {
#	$word = shift @words;
	print "<a href=\"" . &MakeUrl($word) . "\">$word</a><br>\n";
    }

    print &GetForm('day_bottom');

    exit;
}


#
# recent

sub Recent {

    &Connect;

    my $num = $input{'num'} || 50;

    print "Content-type: text/html\n\n";
    
    my $s = "SELECT word,lastentry FROM words ORDER BY lastentry DESC";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my ($word,$date);
    my @words;
    while (($word,$date) = $sth->fetchrow_array) {
	$date = &NormalizeDate($date);

	$firstday = $date unless $firstday;
	$numfirstday++ if $date eq $firstday;

	last if $lastday && $lastday ne $date;
	$lastday = $date if $firstday ne $date;

	push(@words,$word);
    }
    $sth->finish;
    $dbh->disconnect;

    print &GetForm('recent_top');

    # left
    print "<tr><td align=right valign=top>\n";

    my $i;
    for ($i=0;$i<$numfirstday;$i++) {
	$word = shift @words;
	print "<a href=\"" . &MakeUrl($word) . "\">$word</a><br>\n";
    }

    print "</td><td valign=top>\n";

    while (@words) {
	$word = shift @words;
	print "<a href=\"" . &MakeUrl($word) . "\">$word</a><br>\n";
    }

    print "</td></tr>\n";

    print &GetForm('recent_bottom');

    exit;
}


#
# randomlinks

sub Randomlinks {
    &Connect;

    my $s = "SELECT word FROM words";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my $word;
    my @words;
    while (($word) = $sth->fetchrow_array) {
	push(@words,$word);
    }
    $sth->finish;
    $dbh->disconnect;

    srand(time);

    my $num = $input{'num'} || 3;
    $num = scalar(@words) if $num > scalar(@words);

    my %got;
    my $word;
    while ($num) {
	do {
	    $word = $words[rand(scalar(@words))];
	} while ($word eq $input{'from'} || $got{$word});
	$got{$word} = 1;
	$num--;
    }

    my $sep = $input{'sep'} || ' ';
    my $m;
    for (keys %got) {
	$m .= $sep if $m;
	$m .= "<a href=\"" . &MakeUrl($_) . "\">$_</a>";
    }
    print "Content-type: text/html\n\n$m";
    exit;
}

#
# random

sub Random {
    # connect
    &Connect;

    my $s = "SELECT word FROM words";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my $word;
    my @words;
    while (($word) = $sth->fetchrow_array) {
	push(@words,$word);
    }
    $sth->finish;
    $dbh->disconnect;

#    print "Content-type: text/html\n\n@words\n";

    srand();
    do {
	$word = $words[rand(scalar(@words))];
    } while ($word eq $input{'from'});

    print "Location: " . &MakeUrl($word) . "\n\n";

    exit;
}



#
# form

sub Addform {
    $form{'word'} = $input{'word'};
    print "Content-type: text/html\n\n" . &GetForm('addform');
    exit;
}

#
# add

sub Add {
    # check input
    my $errs;
    my ($word) = $input{'word'} =~ /^\s*([\w\']+)\s*$/;
    $word =~ tr/A-Z/a-z/;
    $errs .= "<li>what kind of word is that?\n" unless $word;

    $entry = $input{'entry'};
    $entry =~ s/\s+$//;       # hose trailing whitespace
    # hose html
    $entry =~ s/\<[^\>]*\>//g;
    $entry =~ s/[\<\>]//g;
    # whitespace/linebreaks
    $entry =~ s/\n/\n<br>\n/g;
    $entry =~ s/\s+/ /g;
    # quotes
    $entry =~ s/"/\\"/g;
    $errs .= "<li>and what do you have to say about it?\n" unless $entry;

    my ($email) = $input{'email'} =~ /(\S+)/;
    if ($email) {
	my ($t) = $email =~ /(\w+\@[\w\.]+)/;
	$errs .= "<li>what kind of email address is $email?\n" unless $t;
	$email = $t if $t;
    }

    my ($name) = $input{'name'} =~ /^\s*(.+)\s*$/;
    $name =~ s/[^\w\s\.\!\@\#\$\%\^\&\*\(\)\[\]\~\-\_\<\>\:\;\/\?\{\}\\\|\"]//g;    
    $name =~ s/\s+/ /g;
    $name =~ s/"/\\"/g;
#    $name = 'somebody' unless $name ne '';
    $errs .= "who?" unless $name;

    # connect
    &Connect;

    # did they already submit this?
    $s = "SELECT word FROM entries WHERE word=\"$word\" AND name=\"$name\" AND email=\"$email\" AND entry=\"$entry\"";
    $sth = $dbh->prepare($s) || die "can't prep $s\n";
    $rc = $sth->execute || die "can't exec $s\n";
    if ($sth->fetchrow_array) {
	$errs .= "didn't you already say that?  (look at <a href=\"" . &MakeUrl($word) . "\">$word</a>)\n";
    }
    $sth->finish;

    if ($errs) {
	$dbh->disconnect if $dbh;
	$form{'errs'} = $errs;
	&ShowErrorPage('badinput');
    }

    # modify words
    my $s = "SELECT numentries,curentry,created FROM words WHERE word=\"$word\"";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my ($numentries,$curentry,$created);
    my $r;
    ($numentries,$curentry,$created) = $sth->fetchrow_array;
    $sth->finish;

#    if ($curentry || $numentries) {
	# already have it
	$numentries++;
	$curentry++;
	$s = "REPLACE INTO words (word,numentries,curentry,created,lastentry) VALUES (\"$word\",\"$numentries\",\"$curentry\",\"$created\",NOW())";  
#    } else {
#	# new word. 
#	$curentry = 1;
#	$numentries = 1;
#	$s = "INSERT INTO words (word,numentries,curentry,created,lastentry) VALUES (\"$word\",\"$numentries\",\"$curentry\",NOW(),NOW())";
#    }
    $dbh->do($s) || die "trouble inserting/modifying into words.. $s\n";

    # ok.. add entry
    $s = "INSERT INTO entries (word,id,replyto,name,email,entry,stamp,remoteaddr) VALUES (\"$word\",\"$curentry\",\"$input{'replyto'}\",\"$name\",\"$email\",\"$entry\",NOW(),\"$ENV{'REMOTE_ADDR'}\")";
    $dbh->do($s) || die "trouble adding entry\n";

    # build this page
    &BuildWordPage($word);
    
    $dbh->disconnect;
    
    print "Location: " . &MakeUrl($word) . "\n\n";
    exit;
}



# cgi shiite

sub GetInput {
    my($buffer,$name,$value,@pairs);
    
    # passed from shell on command line..
    for (@ARGV) {
        if (/=/) {
            ($name,$value) = split(/=/,$_);
            $input{$name} = $value;
            $rawinput{$name} = $value;
        } else {
            $command = $_;
        }
    }

    # passed via URL ...

    @pairs = split(/[;&]/,$ENV{'QUERY_STRING'});
    push(@pairs,split(/[\/]/,$ENV{'PATH_INFO'}));
    for (@pairs) {
        next if $_ eq '';
        if (/=/) {
            ($name,$value) = split(/=/,$_);
            $rawinput{$name} = $value;
            $value = &Decode($value);
#            $value =~ tr/[\|\>\<]//;
            $input{$name} = $value;
        } else {
            $command = $_;
        }
    }
    

    # POST method
    
    read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    @pairs = split(/&/,$buffer);
    for (@pairs) {
        ($name,$value) = split(/=/,$_);
        $rawinput{$name} = $value;
        $value = &Decode($value);
#        $value =~ tr/[\|\>\<]//;
        $input{$name} = $value;
    }
    
    1;
}

sub Decode {
    my($value) = @_;

    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    $value;
}
