
#use strict;
use DBI;




#
# HaveWord

sub HaveWord {
    my $word = shift @_;

    my $s = "SELECT word,numentries FROM words WHERE word=\"$word\"";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";
    my ($name, $numentries);
    my $r;
    $numentries = 0;
    if (($word,$numentries) = $sth->fetchrow_array) {
	$numentries = 1 unless $numentries;
    }
    $sth->finish;
    return $numentries;
}



#
# BuildWordPage

sub Encode {
    my($value) = @_;	
    
    $value =~ s/(\W)/'%' . (0 .. 9, 'A' .. 'F')[unpack("C",$1) >> 4] . (0 .. 9,
	 'A' .. 'F')[unpack("C",$1) & 15]/eg;
    
    $value;
}

sub BuildWordPage {
    my $word = shift @_;
    my $verbose = shift @_;

    # open
    my $fn = &MakeFn($word);
    open(O,">$htmldir/$fn.html") || die "can't write to $htmldir/$fn\n";

    $form{'word'} = $word;
    $form{'baseurl'} = $baseurl;
    $form{'cgiurl'} = $cgiurl;
    print O &GetForm('wordtop');

    # entries
    my $s = "SELECT word,id,stamp,replyto,name,email,entry FROM entries WHERE word=\"$word\" ORDER BY stamp";
    my $sth = $dbh->prepare($s) || die "can't prep $s\n";
    my $rc = $sth->execute || die "can't exec $s\n";

#    my %form;
    my ($when,$replyto,$email,$entry,$b);
    my $lastword;

    while (($b,$form{'id'},$when,$replyto,$form{'name'},$form{'email'},$entry) = $sth->fetchrow_array) {
	$semail = &Encode($form{'email'});
	$sname = &Encode($form{'name'});
#	print "email = $form{'email'}  semail = $semail\n";
	if ($form{'email'}) {
	    $form{'who'} = "<a href=\"$cgiurl?who;name=$sname;email=$semail\" class=\"noline\">$form{'name'}</a>" if $form{'name'};
	    $form{'who'} = "<a href=\"$cgiurl?who;email=$semail\" class=\"noline\">$form{'email'}</a>" unless $form{'name'};
	} elsif ($form{'name'}) {
	    $form{'who'} = "<a href=\"$cgiurl?who;name=$sname\" class=\"noline\">$form{'name'}</a>";
	} else {
	    $form{'who'} = 'somebody';
	}
	$form{'when'} = &NormalizeDate($when);
	
	# entry
	my %words,%did;
	%did = ();
	%words = ();
	my @w = split(/\s+/,$entry);
	my ($w,$l);
	for $w (sort @w) {
	    ($l) = $w =~ /\b([\w\']+)/;
	    $l =~ tr/A-Z/a-z/;
	    next if $did{$l};
	    next if $l eq $word;
	    $did{$l} = 1;
	    if (&HaveWord($l)) {
		print " $l" if $verbose;
		$words{$l} = &MakeUrl($l);
		
		# update ref
		my $i = "REPLACE INTO entrywords (word,entryword,id) VALUES (\"$word\",\"$l\",$form{'id'})";
		$dbh->do($i) || warn "can't do $i\n";
	    }
	}
	$form{'entry'} = '';
	my $ww;
	for $w (@w) {
	    ($ww) = $w =~ /\b([\w\']+)/;
	    $l = $ww;
	    $l =~ tr/A-Z/a-z/;
	    if ($words{$l}) {
		my $u = "<a href=\"$words{$l}\">$ww</a>";
		$w =~ s/$ww/$u/;
	    }
	    $form{'entry'} .= $w;
	    $form{'entry'} .= ' ';
	}

	print O &GetForm('wordsep') if $lastword;
	print O &GetForm('entry');

	$lastword = $form{'word'};
    }
    $sth->finish;

    # tag lastbuilt
#    $s = "REPLACE INTO words (word,lastbuilt) VALUES (\"$word\",NOW())";
    $s = "UPDATE words SET lastbuilt=NOW() WHERE word=\"$word\"";
    $dbh->do($s) || warn "can't update lastbuilt in words: $s\n";
	
    print O &GetForm('wordbottom');
    close O;

    chmod 0666,"$htmldir/$fn.html";

    return 1;
}


#
# GetForm

sub GetForm {
    my $form = shift;
    my $scheme = shift || $edition;  #defaultscheme;
    my ($f,$before,$middle,$after);

    open(FORM,"$formdir/$scheme/$form.html") || open(FORM,"$formdir/$form.html") || return;
    $f = join("",<FORM>);
    close FORM;

    for (keys %form) {
        $f =~ s/--$_--/$form{$_}/g;
        ($before,$rest) = split(/{{$_}}/,$f);
        if ($rest) {
            ($middle, $after) = split(/{{\/$_}}/,$rest);
            $f = $before . $after if $form{$_} eq '';
            $f = $before . $middle . $after if $form{$_} ne '';
        }
    }

    $f =~ s/--baseurl--/$baseurl/g;
    $f =~ s/--cgiurl--/$cgiurl/g;
    $f =~ s/--basedir--/$basedir/g;

    $f =~ s/--\w+--//g;

    $f;
}


sub MakeUrl {
    my ($w) = @_;
    $w =~ s/\'/_/g;
    $baseurl . '/'. substr($w,0,1) . "/" . $w . ".html";
}

sub MakeFn {
    my ($word) = @_;
    my $fn = substr($word,0,1) . '/' . $word;
    $fn =~ s/\'/\_/g;
    $fn;
}

sub NormalizeDate {
    my ($date) = @_;
    substr($date,2,2) . substr($date,5,2) . substr($date,8,2);	
}


sub GetErrorPage {
    my ($page,$error) = @_;

    my $p = &GetForm($page);
    $p =~ s/--error--/$error/g;

    $p;
}

sub ShowErrorPage {
    my ($page,$error) = @_;
    print "Content-type: text/html\n\n" . &GetErrorPage($page,$error);
    exit;
}


1;
