#!/usr/bin/perl 

#use strict;
use DBI;

require "/home/sage/blather/bin/config.ph";
require "$basedir/bin/blib.ph";

my $edition = shift @ARGV;
my $datasource = "blather$edition";

if ($edition) {
    $htmldir .= "/$edition";
}


# connect
$dbh = DBI->connect("dbi:mysql:$datasource:$dbhost", $dbuser, $dbpass)
    || warn "Can't connect to $datasource: $DBI::errstr";


my $s = "select count(word) from words";
my $sth = $dbh->prepare($s) || die "can't prep $s\n";
my $rc = $sth->execute || die "can't exec $s\n";
my ($words) = $sth->fetchrow_array;
$sth->finish;

$s = "select count(word) from entries";
my $sth = $dbh->prepare($s) || die "can't prep $s\n";
my $rc = $sth->execute || die "can't exec $s\n";
($entries) = $sth->fetchrow_array;
$sth->finish;

# disconnect
$dbh->disconnect   || warn $dbh->errstr;

print "word = $words, entries = $entries\n";

open(O,">$htmldir/numwords.html");
print O $words;
close O;
open(O,">$htmldir/numentries.html");
print O $entries;
close O;
exit;



