#!/usr/bin/perl 

#use strict;
use DBI;

require "/home/sage/blather/bin/config.ph";
require "$basedir/bin/blib.ph";


$edition = shift @ARGV;
$edition = '' if $edition eq '-';
if ($edition) {
    $htmldir .= "/$edition";
    $baseurl .= "/$edition";
    $dbname = "blather_$edition";
    $cgiurl .= "/edition=$edition";
}

my $interval = shift @ARGV;   # partial rebuild!

# connect
my $datasource = $dbname;
$dbh = DBI->connect("dbi:mysql:$datasource:$dbhost", $dbuser, $dbpass)
    || warn "Can't connect to $datasource: $DBI::errstr";


# get wordlist
my $s;
if ($interval) {
	my $entry;
	my $ss = "select entry from entries where stamp >= date_sub(now(), interval $interval)";
	print "$ss\n";
	my $sth = $dbh->prepare($ss) || die "can't prep $ss\n";
	my $rc = $sth->execute || die "can't exec $ss\n";
	while (my ($e) = $sth->fetchrow_array) {
		$entry .= $e . ' ';
	}
	$sth->finish;

	# build my wordlist
	my %words;
	my @w = split(/\s+/,$entry);
	my ($w,$l);
	for $w (sort @w) {
	    ($l) = $w =~ /\b([\w\']+)/;
	    $l =~ tr/A-Z/a-z/;
		$words{$l} = 1;
	}

	my $set;
	for my $w (keys %words) {
		next unless $w;
		$set .= ',' if $set;
		$set .= $dbh->quote($w);
	}
	
	exit 0 unless $set;

	# rebuilt recent entries only!
	$s = "select word from words where word in ($set)";
	print "$s\n";
} else {
	# all entries!
	$s = "SELECT word FROM words";
}
my $sth = $dbh->prepare($s) || die "can't prep $s\n";
my $rc = $sth->execute || die "can't exec $s\n";
my @words;

while (($f) = $sth->fetchrow_array) {
    next unless $f;
    push(@words,$f);
}
$sth->finish;

my $l = 0;
for (sort @words) {
    print "$_:";
    $l += &BuildWordPage($_,1);
    print "\n";
}


# disconnect
$dbh->disconnect   || warn $dbh->errstr;

print "done: " . scalar(@words) . " words.\n";
exit;

